package org.rcisoft.business.cmsActivity.dao;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Param;
import org.rcisoft.business.cmsActivity.entity.CmsActivity;
import org.rcisoft.core.mapper.CyBaseMapper;
import org.rcisoft.core.model.CyPageInfo;

import java.util.List;

/**
* Created with cy on 2024年3月25日 下午1:42:40.
 * @author wangFeilong
 */

public interface CmsActivityRepository extends CyBaseMapper<CmsActivity> {


    List<CmsActivity> queryCmsActivity(@Param("entity") CmsActivity cmsActivity);

    /**
    * web端-分页查询 cmsActivity
    *
    */
    IPage<CmsActivity> queryCmsActivityPaged(CyPageInfo cyPageInfo, @Param("entity") CmsActivity cmsActivity);
    /**
     * app端-分页查询 cmsActivity
     *
     */
    IPage<CmsActivity> appQueryCmsActivityPaged(CyPageInfo<CmsActivity> paginationUtility, CmsActivity cmsActivity);
    //根据id逻辑删除
    int deleteCmsActivity(@Param("businessId")Integer businessId);
    //修改状态
    int updateStatus(@Param("entity") CmsActivity cmsActivity);
    //查询活动详情
    CmsActivity selectById(@Param("businessId")Integer businessId);
    //权重验重
    CmsActivity checkWeight(@Param("weight") Integer weight);

    //查询当前用户是否已报名该活动
    Integer getIsApplication(@Param("userId") String userId, @Param("activityId") Integer activityId);
    //增加活动报名人数
    Integer addApplicationCount(@Param("businessId") Integer businessId);
    //查询活动报名人数
    Integer selectByActivityId(Integer businessId);
    //活动已报名人数-1
    int reduceActivityApplicationCount(Integer businessId);
}

